[VETips]
[VEVersion] [4] [4a]
[NumTips] [53]

[Tip][1] [ Move ve.tps to C:\ ]
Did you have to help VE locate its tips file via an Open
File dialog? You will have to keep doing that each time
you try to view tips until you move the tips file to its
intended location. Where is that? C:\. Move the ve.tps
file to C:\ve.tps and VE will automatically find it each
time you ask to view tips.

Or, if you want to put the ve.tps file elsewhere, define an
environment var $VETIPS to point to the desired directory.
If $VETIPS is defined, VE checks this along with C:\.
Define VETIPS in autoexec.bat via "SET VETIPS=dirname".
[EndTip]

[Tip][2] [ Again Repeats Everything ]
The F1 (Again) key repeats almost all commands except
cursor movement, page movement and file commands.

Need to change several occurences of "blotzo" to "yahoo"?
Type F6 (Substitute) to do it once. Then simply type F1 to
repeat as many times as desired, or until the Substitute
reports that there are no more occurences to change. 

Skipping across a line a word at a time using the
ESC-CurRight (WordRight) command? Move forward one word
then simply press F1 to continue moving across as many
words as desired. Ditto for deleting lines with CTL-x or
inserting copies of a previously deleted line with CTL-c
or any command you last used. F1 repeats everything!
[EndTip]

[Tip][3] [ VE Has Global Undo Support ]
VE features nearly global undo support. Want to undo the 
last thing you changed? Type ESC-u or CTL-z. Just like
magic, your last change is undone. 

Want to undo several changes at once? Use a repetition
count! Type "ESC n u" or "ESC n CTL-z", and up to "n" last
changes will be undone.
[EndTip]

[Tip][4] [ VE Has Strong Multi-file Support ]
VE has extensive support for editing multiple files at 
the same time. Start VE with multiple filenames via

VE file1 file2 ... filen

This will start VE and load all "n" files for editing. Or,
edit a file and then add more as needed with the "ESC-e f"
(Edit, File) command. VE will present a full-screen file
selection dialog to allow you to select an additional file.

Once VE is running with multiple files open, use the
"ALT-Keypad+" (Next File) keystroke to move forward from
one file to another or use the "ALT-Keypad-" keystroke
to move backward to the previous file.

You can also use the "ALT-Keypad*" or ESC-g (Goto File)
keystrokes to bring up a full-screen open file selection
dialog and use that dialog to select the file to move to. 
[EndTip]

[Tip][5] [ Secrets of File Select and Goto File Dialogs ]
In both the Open File and Goto File dialogs, you can use
cursor and page up/down keys to move around the file list.
When you arrive at the file of interest, ENTER will
select it. However, you can also use the mouse to do the
same thing. A single click of the mouse on a filename of
interest will select it. A double click on the same 
filename is equivalent to ENTER.

However, in addition to cursor and mouse selection of
files, you can also directly type in file names. VE will
echo the filename near the bottom of the dialog screen
as you type. Full line editing is supported as you type.
Autocomplete of partially typed file/directory names is
also available, via the TAB key.
[EndTip]

[Tip][6] [ Copy/Paste Between Open Files ]
The line, block and column buffers are core VE resources,
not associated with any one file. So, you can move content
from one file to another by copying it in one file and 
then moving to another and pasting it there. You can move
between open files with ALT-Keypad+ and ALT-Keypad-.

Copy/Paste works for the line buffer (CTL-c, CTL-v), the
Block buffer (ESC-b c], [ESC-b p] and the Column/Rectange
buffer [ESC-c c], [ESC-c p].
[EndTip]

[Tip][7] [ CTL-v Pastes Whatever You Copied Last ]
CTL-c/CTL-v copy and paste a line at a time. This is 
standard GUI fare these days. However, VE's CTL-v
extends this idea, pasting whatever you copied last.

If you copied a line via CTL-c, CTL-v will paste that
line wherever you place the cursor. However, if
you copied a block of lines via [ESC-b c] (Block),
CTL-v will paste that block instead... it is the last
thing you copied! Similarly, if you copied a rectangular
area via [ESC-c c] (Column), CTL-v will paste that
rectangle wherever you place the cursor. 
 
CTL-v pastes whatever you copied last!
[EndTip]

[Tip][8] [ The Column Command Works Inside Rows! ]
The Column/Rectangle command is great for selecting and
copy/cut/paste of rectangular areas. But a rectangle can
be just one line long as well! Hence, the Column command
works within a single row too.

So, do you have a portion of a sentence, or a variable
name that is large and annoying to type? Just select and
copy it via the Column/Rectangle command and paste it 
anywhere you would like, using CTL-v.

You can select within a row using the usual cursor
controls that the Column command supports, but you can 
also use the mouse! To select a single word, just 
double click within it. This selects the word and runs
the Column/Rectangle command with the word selected.
[EndTip]

[Tip][9] [ VE Supports the Mouse ]
VE supports mice. When VE starts, the mouse pointer is not
visible. To make it visible, left click it. You can also do
this using the ALT-m (Show/Hide Mouse) keystroke. That same
ALT-m keystroke will hide the mouse pointer too.

Position the cursor anywhere on screen by moving the mouse
pointer and single clicking. Select words by double
clicking them. This starts the Column/Rectangle command
with the word pre-selected. Select larger rectangular
areas by left clicking one corner of the area and right
clicking the other. You can also click and drag,
but there is no on-screen feedback until you release
the mouse button. Both of these start the Column
command with the area pre-selected.
[EndTip]

[Tip][10] [ ENTER Exits Most Dialogs ]
The ENTER key exits most dialogs that VE presents on the
status line or on other areas of the screen. Just type
ENTER by itself and VE will either exit the dialog you are
in, or move up from a subcommand of that dialog back to
the main level of the dialog, where another ENTER will
then exit back to the file.
[EndTip]

[Tip] [11] [ Accumulate Content in Block, Column Buffers ]
You can do more than just copy and paste selected areas
using the Block and Column/Rectangle buffers. You can also
accumulate content in them, and then paste the accumulated
content in one paste operation.

Select an area to copy into the block buffer and do so
with the "ESC-b c" keystroke. Now find another line or 
group of lines you would like to ADD to the ones you
already have in the block buffer. Append them to what 
is already there with the "ESC-b a" keystroke. Continue
selecting and appending as often as you like. When
you are ready, paste the entire set of content from the
block buffer with one CTL-v (Paste) operation!

Magic!  ... and it works with the Column buffer too!
[EndTip]

[Tip] [12] [ Accumulate Content in the Line Buffer ]
You can do more than just copy and paste single lines with
CTL-c/CTL-v. VE extends this idea, adding CTL-a, which
accumulates content in the line buffer, similar to how 
content can be accumulated in the Block and Column buffers.

Type CTL-c/CTL-x to copy a line into the line buffer. Now
move to another line that you would like to ADD to those
already in the line buffer and type CTL-a. This appends the
line to those already in the buffer. Continue appending
until you have accumulated all of the desired content, and 
then paste the entire set with one CTL-v operation!
[EndTip]

[Tip] [13] [ Simplify the Complex with Auto Macros ]
If you need to perform a complex set of editing steps
repeatedly, VE lets you define on-the-fly "auto" macros,
and then execute them as often as desired.

Type ALT-a to start the definition of an auto macro. VE
displays "(m)" on the status line to indicate it is 
learning your keystrokes. When you have completed one
instance of the complex steps you need to take repeatedly,
type ALT-a again. This completes the learning of the macro
and you can now execute it repeatedly via ESC-x or ALT-x.

Or, you can execute the auto macro once via ESC-x or ALT-x,
and then repeat it as desired with F1 (Again). Or run
it several times in a row with a repetition count - type 
"ESC n ALT-x." and it will execute "n" times.
[EndTip]

[Tip][14] [ Use Auto Macros Over and Over ]
Do auto macros make your life simpler? Keep using them
again and again in the same editing session. After you 
have defined an auto macro and used it as needed, you
can simply define a new one using the same ALT-a
keystroke. VE will silently discard your previous auto
macro and let you define a new one. The same ESC-x or
ALT-x keystroke will run the new auto macro as ran the
previous one. You can keep redefining auto macros
indefinitely, using each one to full advantage.
[EndTip]

[Tip][15] [ Add Content Near Line End ]
Need to add content well to the right of existing content
on a line? Dont hold down the space bar to move over to 
where you want to start adding. Let VE do it for you!

Simply move up or down to another line that ends roughly
near the same place, type the End key to move to the end
of that line and then cursor up/down back to the line you
want to add content to and start typing. VE will
automatically fill the space from the last content on the
line to the new content with spaces! 

This feature can dramatically decrease text entry time.
[EndTip]

[Tip][16] [ VE Supports 80x25 and 80x50 on VGA ]
Is the DOS standard screen size of 80x25 to small to
contain what you are working on? No worries! VE also
supports 80x50 on most standard VGA hardware. This
means that you can double the number of lines of text
visible at a glance, which is often very helpful.

To make use of 80x50 just start ve with the -s 80x50
option, like this: ve -s 80x50 filename. Thats all it
takes. VE will increase the resolution to 80x50 until
you exit. At that time, VE will return it to 80x25.
OR... if you have another means of getting the screen
into 80x50 mode, and then you start VE, it will just
recognize this and use 80x50 automatically. BTW, yes
VE also recognizes a "-s 80x25" option!
[EndTip]

[Tip][17] [ VE Makes Indenting Easy ]
Need to indent a group of lines by a fixed number of
spaces? For example, changing the indent level on a 
block of source code. Don't do it manually per line.
Let VE do the whole group of lines in one step.

To indent a whole group of lines at once, use the Column
command. Type ESC-c, then cursor down (or page down) to
the bottom of the block of lines. Now cursor over as many
spaces as you want to insert and type "i" (insert).VE will
insert that many spaces across the entire block. Easy!
Remember that the column you start on counts as 1 already,
so if you want to indent by 3, cursor over an extra 2.

Want to reduce the indent level instead of increasing it?
The same idea works the same way. Just use the 'd' command
instead of the 'i' command.
[EndTip]

[Tip][18] [ VE Formats/Wraps Text ]
If you are writing a letter or some other document in VE
and you would like it more nicely formatted, let VE do it
for you. With your cursor inside a paragraph that you
would like reformatted, type ESC-w (Wrap). VE will reformat
the paragraph to a consistent line size, and even right
justify each line if that option is enabled.

VE's text formatting capability knows lots of tricks. It 
understands letter format, where the first line of a 
paragraph is indented more than the remainder of the 
paragraph. It understands bulleted lists and will respect
the list structure as it formats. It even understands 
indent levels, and will respect existing indents as it
formats. Try it - you will like it.
[EndTip]

[Tip][19] [ On-The-Fly Text Wrapping ]
VE has a modicum of word processing ability built in. 
With on-the-fly text wrapping enabled, VE will wrap your
typing in real time. This is a nice alternate to wrapping
it after-the-fact with the ESC-w (Wrap) command.

To enable on-the-fly text wrapping (a.k.a. Power Typing 
for VE users who remember the VE v1.03 QNX original, type
ESC-o to bring up the Options command. Select Wrap/Power.
Select Enable. Thats it! Start typing and VE will wrap 
your text in real time. 

You can change both the left and right margins that the
text is wrapped between, and enable/disable right
justification, all via the Options Wrap/Power command.
While Wrap/Power is enabled, VE will display "(w)" or 
"(p)" in the option area of the status line.
[EndTip]

[Tip][20] [ Shell Out to DOS When Needed ]
VE supports shelling out to DOS if you need to check on
something while editing. Just type ALT-d and off you go.
Type "exit" when you are done with DOS to return to VE.

Note that when editing large files, or simply lots of
files, the 16-bit version of VE (ve.exe) may not be able
to shell out due to insufficient memory. It will give you
an error in this case. The 32-bit version of VE (ve32.exe)
uses virtual memory, and can typically shell out to DOS
unless you are editing many large files.
[EndTip]

[Tip][21] [ VE Keeps Track of Your Changes ]
Have you ever noticed the little magenta-colored diamond
that appears from time to time next to the name of the
file you are editing? It is an "unsaved changes" indicator,
and is VE's way of letting you know that there are unsaved
changes in the file you are working on. When you see the 
indicator on, you know that you might need to save the 
current file before discarding it.
[EndTip]

[Tip][22] [ Move Around the Screen Like a Pro ]
There are lots of ways to move all over the screen quickly,
instead of laboriously cursoring there with the four cursor
keys. 

CTL-t moves you to the top of the screen. CTL-b moves you
to the bottom of the screen. CTL-g moves to the center of
of the screen. This all makes spatial sense... on the
keyboard, "g" is right between "t" and "b".

CTL-q moves you to the left edge of the screen and CTL-p 
moves you to the right edge. CTL-y moves you to the middle.
This also makes spatial sense. "q" is the leftmost alpha
key on the keyboard, "p" is the rightmost, and "y" is sort
of in the middle between those two.
[EndTip]

[Tip][23] [ More Screen Movement Secrets ]
An earlier tip told you about CTL-t/g/b for moving to the
top, center and bottom of the screen, and CTL-q/y/p for 
moving to the left edge, middle and right edge of the
screen. There is another way to do many of these using
keypad keys! These keys only work when NumLock is off, but
VE turns it off when it starts. Don't turn it back on!

The keypad "5" key is located in the center of the keypad
between the four keypad arrow keys. The "5" key will move 
the cursor to the screen edge that lies in the same 
direction as the last cursor movement key. So, to go to the
top edge, type CursorUp and then "5". To go to the bottom 
edge, type CursorDn and then "5". Similarly, for the left 
and right edges, type CursorLeft and "5" and CursorRight
and "5". Nice!
[EndTip]

[Tip][24] [ More Secrets of the Goto File Dialog ]
An earlier tip told you about how to select files using
VE's full-screen Goto File Dialog. Besides helping you
move between open files, this dialog has two more tricks.

If you have multiple files open at the same time, and you
want to discard one or more of them without having to 
to go back into each one and discard it via the "ESC-q, d"
(Quit, Discard) command, there is a simple way. Access the
Goto File dialog (ESC-g or ALT-Keypad*), cursor to a file 
you want to discard and press the Delete key. Poof! The 
file is discarded. If it has unsaved changes, the magenta
colored change indicator will show next to its name. You
can save those changes AND discard it by typing CTL-s.

Easy clean up of the debris left by multi-file workouts!
[EndTip]

[Tip][25] [ Change Case the Easy Way ]
You almost certainly have wanted to change the case of one
or more letters on screen at one time or another. VE makes
this easy. Just type ALT-~ (ALT-` is also supported, as 
this is the same key, just without SHIFT held down) and 
the case of the letter will be changed from lower to upper
or visa versa.

Have more letters to change the case of? Just keep typing
ALT-~. This versatile little command moves forward or 
backward each time, depending on the last direction you
moved the cursor. If you cursored left, it moves left. If
you cursored right, it moves right. Enjoy! BTW, this is one
of the few VE commands that doesn't have an undo. It just
isn't needed - to undo it, just repeat it!
[EndTip]

[Tip][26] [ Pick a Line, Pick a Column ]
From time to time, you may want to move a line to the
top of the screen so that you can see the full scope of
what lies below it. VE supports this and calls it 
"vertical pick". You do it by putting the cursor on the
line of interest and typing ESC-z or CTL-z.

VE also supports "horizontal pick", which is moving a
particular column to the left edge of the screen, so that
you can see the full scope of what lies to its right. Just
position the cursor to the column and type ESC-z or CTL-z.

Same keystroke for both, right? VE executes vertical pick 
(move line to top of screen) if the cursor is at the left
edge of the screen (column 0) at the time of ESC-z/CTL-z.
VE executes horizontal pick (move column to left edge of
screen) when the cursor is in any other column. Pick away!
[EndTip]

[Tip][27] [ Using Tags in VE ]
VE lets you mark a particular line of interest in a file
with a "tag", and then jump back to that tag at will. VE
supports up to 10 tags, numbered 0 through 9. To set a 
tag, type "ESC-t n", where "n" is the tag number (0-9).
To return to that tag, type "ESC-j t n" (Jump, Tag, n)
and VE will return to the tagged line number.
[EndTip]

[Tip][28] [ About VE - A Short History ]
This isn't quite an "Easter Egg", but if you type ESC-A,
VE pops up a full screen window with a short history of
VE, which you will see starts in 1983 and continues to
this very day. Enjoy!
[EndTip]

[Tip][29] [ Peeking Under the Hood ]
Are you the curious type, interested in what is going on
behind the scenes in VE? Excellent! Type ESC-s (Status) 
and VE will present a full screen of details about its
overall internal technical status.
[EndTip]

[Tip][30] [ VE is Word Aware ]
No, not Microsoft Word aware, lexical word aware! VE 
understands the concept of words. You can delete words,
you can move to the right or left a word at a time, and
you can even move to the right from word end to word end.

To delete a word, put the cursor before the word and type
ESC-Delete or ALT-Delete. To move one word to the right, 
type ESC-CursorRight. Predictably, ESC-CursorLeft moves
one word to the left. Do either one once and then press
F1 (Again) to keep moving by words until you get where 
you want to go. Finally, CTL-k moves to the right from
word end to word end (the others move to word starts).
[EndTip]

[Tip][31] [ Moving Up/Down/Left/Right by Halves ]
PgUp and PgDown are great keys for moving through files,
but what if you want to move up/down by just half a screen?
VE lets you do this. Instead of PgUp/PgDn, type ALT-PgUp or
ALT-PgDn. VE moves the screen up or down by half.

There aren't Page Right or Page Left keys to scroll the
display a page to the right/left at a time, but there ARE
VE keystrokes to scroll the display a HALF page to the right
or a HALF page to the left.

To scroll the display half a page to the right, type
ALT-CursorRight. To do the same to the left, type
ALT-CursorLeft. Note that when scrolled to the right, VE
presents a "scrolled" indicator in the screen upper right.
[EndTip]

[Tip][32] [ VE Supports a Wide Canvas ]
The typical DOS display is just 80 columns wide, but VE's 
view of your file is much wider... up to 384 columns wide.
The VE display you see is an 80 column viewport logically
floating over an up to 384 column wide file area. VE moves
the viewport right and left as you edit.

Some examples: if you type beyond column 79, VE scrolls the 
viewport one column to the right. Keep typing and it keeps
scrolling. If your file is wider than 80 columns, the End
key will scroll the viewport so that you can see the end of
a line. The Home key will snap it back to Column 0. 

Want to scroll the viewport yourself manually? Go ahead!
Type ALT-CursorRight to scroll a half page to the right. 
Scroll a half page to the left with ALT-CursorLeft.
[EndTip]

[Tip][33] [ VE Is Both 16 and 32 Bits ]
VE 4.0c is available in two builds: ve.exe, a 16-bit
build created with Borland C/C++ v3.1, and ve32.exe,
a 32-bit build created with DJGPP C/C++. Both have the
same feature set.

The 16-bit ve.exe has a smaller executable and is faster
to load, but paradoxically, it occupies more lower RAM
than ve32.exe.

ve32.exe has a larger executable and is slightly slower
to load. Despite the larger executable, it inherits virtual
memory support from the underlying DJGPP runtime base and
occupies LESS lower RAM than ve.exe. Due to its virtual
memory support, ve32.exe has the primary virtue of being
able to edit much larger files, more files, or both.
[EndTip]

[Tip][34] [ VE Can Edit Really Big Files ]
VE was designed to handle really big file and/or lots of 
files simultaneously. Both have been key design objectives
from "day 1".

How big? The 32-bit ve32.exe (see earlier tip on the 16 and
32 bit builds for VE v4.0c) supports files up to 1.3MB in
size, which in testing equated to about 32,000 lines of text.
The 16-bit ve.exe can handle files up to 250KB in size, or
about 6,200 lines of text.

How many files? Both versions of VE support up to 256 
simultaneously open files.
[EndTip]

[Tip][34] [ CTL-s Saves/Updates File ]
An old GUI standby, CTL-s, saves/updates the file you are
are working on and then returns to editing. This has the
same effect as F11, which also does this, or the long form
of F11, "ESC-q u" (Quit, Update), which despite the name
does not quit, it just updates the file.

If you worry about DOS/Windows crashing underneath you and
loosing your work, at least in VE you can just type CTL-s 
frequently and never be concerned again. VE can't fix DOS
or Windows, but it can make sure that you don't loose your
work if either one decides to "go for for a spacewalk"!
[EndTip]

[Tip][35] [ Recover From Screen Errors with ESC-v ]
Like all good text editors, VE is WYSIWYG - What You See
Is What You Get. Every once in a very long while however,
VE may fail to be be WYSISYG.

In the unlikely event that you stumble across an undetected
bug that messes up anything on the screen display, you can
recover the correct screen display by typing ESC-v (View).
This resynchronizes what is displayed on screen with the
content of VE's logical view of what should be there.

If you should find such a bug, and can reliably reproduce
it, PLEASE report the bug and the steps to reproduce it to
webmaster@inverary.net. There is a $10 bounty on such
bugs! If you are the first to report a new previously 
undetected bug, inverary.net will send you a crisp new
$US 10 bill (or equivalent check in your local currency)!
[EndTip]

[Tip][36] [ Delete Left and Right! ]
A common editing requirement is to delete everything from
the cursor position to the end of the line, or from the 
cursor position to the start of the line. VE makes it 
easy to do both. 

F10 deletes everything from the cursor position to the end
of the line. ESC-k does the same thing. 

ESC-d deletes everything from the cursor position to the
start of the line.
[EndTip]

[Tip][37] [ TAB Support in VE ]
When reading files that have TABs in them, VE can either
leave them as is, or expand them to an equivalent number
of spaces. Similarly when writing files, VE can compress
consecutive spaces into TABs or just write the file as is.
VE defaults to NOT expanding TABs when reading and NOT
compressing spaces to TABs when writing.

To make TABs uniquely visible, VE displays TAB characters
as a green carat symbol. This looks good with VE's default
color schema of white on blue.

The "ESC-o t" (Options, Tab) command allows users to change
the input TAB transalation, output TAB translation and
tabstop settings that VE uses. Once changed, the changes
can be made permanent by choosing the "ESC-o s"
(Options, Save) command. This writes file ve.opt or 
ve32.opt to $HOME or C:\ if $HOME is not defined.
[EndTip]

[Tip][38] [ Customize VE's Screen Colors ]
VE defaults to using white letter on a blue background.
This color schema seems to suit most users. However, if
you want something different, the "ESC-o c" (Options,
Colors) command will be your friend.

In the (Options, Colors) menu, type "f" (foreground color)
and type in the desired foreground (typed characters)
color. Type "b" and set the background color as desired.
Now type "a" (Apply) and VE will change to your new
color schema. To see the full set of available color names,
type "p" (Palette).

If you want to make these changes permanent, exit out of
the Colors subcommand, and back at the main Options command
level, type "s" (Save). This writes the file ve.opt or 
ve32.opt to $HOME or C:\ if $HOME is not defined.
[EndTip]

[Tip][39] [ Match Start and End of Line ]
When searching for text with the Find or Replace commands
(F5 or F6, ESC-f or ESC-r), it is sometimes useful to find
strings only when they occur at the start of a line, or at
the end of a line. VE supports this.

To search for a string that occurs at the start of a line,
enter "^search pattern" at the Find command prompt. To
search for a string that occurs at the end of a line, enter
"search pattern$" into the Find command prompt.

Don't like the Start-of-Line or End-of-Line matching chars
(^ and $ respectively)? You can change them via the
"ESC-o m" (Options, Match) command and save the change
permanently with the "ESC-o s" (Options, Save) command.
[EndTip]

[Tip][40] [ Where Am I? ]
At any time while editing a file, you can ask VE what line
number and column number you are at, and what percentage
through the file you are. Simply type "ESC-i" (Info) and
VE updates the status line with the information.

Some VE commands also provide this information as part of 
their function. For example the Find command moves to the
text that was searched for and then udpates the status line
with that text's line/column/percentage information. The
Home and End commands do so too, as does the Jump command.
[EndTip]

[Tip][41] [ Delete Single Lines with Ease ]
VE supports many ways to delete single lines, or groups of
single lines, but probably the easiest way to do this is 
with the F9 (Delete Line) command. To delete several 
consecutive lines, press F9 repeatedly, or pair it with a 
repetition count, per "ESC n F9", where "n" is the number
of lines you wish to delete. ESC-l is another way to access
the Delete Line command.

BTW, an old GUI standby, CTL-x, is yet another way. It does
the same thing as F9 AND it copies the deleted lines into
the line buffer for later pasting elsewhere!
[EndTip]

[Tip][42] [ VE Makes Indenting Easy - Part 2 ]
In an earlier tip, we learned how to indent (or unindent)
multiple columns with one ESC-c (Column) command. In this
tip, an even simpler way to do the same thing with ESC-c!

Want to indent a group of lines by several spaces? Use the
ESC-c (Column) command and cursor down to encompass the 
lines you want to indent. Now type "i" (Indent) and VE
indents your lines by one space. Now just type F1 (Again)
and VE will indent your group of lines another space. 
Keep pressing F1 until you have as many spaces of indent
as you want. This is a visually pleasing way of indenting;
it happens in real time on the screen, an indent at a time.

The same works for unindenting. Instead of "i", type "d"
(Delete). The rest works exactly the same way!
[EndTip]

[Tip][43] [ A Quick Map of the Fn Keys ]
The most used VE functions are mapped to the 12 Function
keys on the extended PC keyboard. Here are their uses:

F1  - Again (repeats last command)
F2  - Block (select, copy/paste/delete lines)
F3  - Column (select, copy/paste/delete rectangles)
F4  - Jump (to line numbers, tags, start/end of file)
F5  - Find
F6  - Replace (also called Substitute by VE)
F7  - Paste (also CTL-v)
F8  - Edit Command (add more files, switch files, etc.)
F9  - Delete Line
F10 - Delete to End of Line
F11 - Update file to disk (also CTL-s)
F12 - Quit (includes Update, Write/SaveAs, Discard)

[EndTip]

[Tip][44] [ VE Makes Indenting Easy - Part 3 ]
In an earlier tip, we learned that you can indent a group
of lines and then use F1 (Again) to repeat that action,
allowing you to indent with real time visual feedback.

A nice refinement to this is that instead of using the 'i'
(Insert) subcommand of the Column command to do it, you can
use the keyboard Insert key in its place. When you do this,
you can press the Insert key again ..and again ..and again!
In fact, you can repeat the indent action as many times as
you want by continuing to press the Insert key. Nice!

It works for the Delete key too! Instead of pressing 'd', 
to unindent, use the Delete key. Repeat the unindent by
continuing to press the Delete key repeatedly. Even nicer!
[EndTip]

[Tip][45] [ VE Has Three Layers of Help ]
VE has three layers of help to ensure that you get the most
out of it. 

The first layer is the built-in help, a three screen VE
command summary. It is always available via ALT-h.

The second layer is these tips. You are reading them, so
you know how to access them! They provide the next level
of detail, 1 topic per tip. They require file c:\ve.tps.

The third and last layer is the user manual, a rougly
100 page detailed user guide. It should have been provided
with your install package. Go to www.inverary.net/ve
and download it if you don't have it. Well worth it!
[EndTip]

[Tip][46] [ Make VE Faster on Slower PCs ]
Combining a small executable, blazing speed and a powerful
feature set has been a core design principle of VE from
its very beginnings. v4.0 however introduced two new CPU
heavy features, Change Indicator and Software Cursor
whose performance impact may be felt on slower PCs such
as 286s and early 386s. 

Consequently, either or both of these features can be
disabled via the Options (ESC-o) command. Type ESC-o,
and then "b" to select the BasePerf (Base Performance)
subcommand. From here, you will see options to enable
or disable each of Software Cursor and Unsaved Changes
Indicator. Try disabling one or both as needed if you
are on a slower PC and want to enjoy VE's characteristic
snappy performance.
[EndTip]

[Tip][47] [ VE Software Cursor ]
Tired of the old blinking hardware cursor that most DOS PCs
present? So was VE, and so in v4.0, the "software cursor"
made its debut. It is the solid non-blinking colored block
cursor that VE employs by default as of v4.0.

VE's default color schema of white on blue employs magenta
as the cursor color, but like all of VE's colors, this can
be changed via the Options menu (ESC-o). Type ESC-o, then 
"c" to select the Colors submenu. From there, you can make
changes to the foreground (text), background and cursor 
colors. Experiment until you achieve the look you want and
then save your options via the "s" subcommand of the Options
menu. VE will automatically load these saved options each
time it starts, making your color selections permanent.
[EndTip]

[Tip][48] [ Insert a File ]
VE can insert the contents of an external file into 
the file currently being edited. 

Use the [Block, Read] command (ESC-b,r) to read in an
external file and insert it as a series of lines.

Use the [Column, Read] command (ESC-c, r) to read in an
external file and insert it as a column area (i.e. at
any arbitrary column).
[EndTip]

[Tip][49] [ Save Selected Area to a File ]
VE can write out a selected area of the file currently
being edited as an external file. 

Use the [Block, Save] command (ESC-b,s) to save a selected
set of lines to an external file. 

Use the [Column, Save] command (ESC-c,s) to save a selected
column area to an external file.
[EndTip]

[Tip][50] [ Strip Trailing White Space from Lines ]
Need to strip the trailing white space from the end of lines
in a file? VE can do that! When Output Tab Translation is 
enabled, VE not only compresses spaces with Tabs, it also
strips any trailing white space from each line. 

So, to strip trailing white space from all lines of a file,
enable Output Tab Translation [Options, Tabs] (ESC-o, t),
save the file [Quit, Save] (ESC-q, s), restart VE, enable
Input Tab Translation [Options, Tabs], and read the file
back in [Edit, File] (ESC-e, f). Trailing white space, gone!
[EndTip]

[Tip][51] [ VE Supports 80x25 and 80x43 on EGA ]
Is the DOS standard screen size of 80x25 to small to
contain what you are working on? No worries! VE also
supports 80x43 on most standard EGA hardware. This
means that you can increase the number of lines of
text visible at once, which is often very helpful.

To make use of 80x43 just start ve with the -s 80x43
option, like this: ve -s 80x43 filename. Thats all it
takes. VE will increase the resolution to 80x43 until
you exit. At that time, VE will return it to 80x25.
OR... if you have another means of getting the screen
into 80x43 mode, and then you start VE, it will just
recognize this and use 80x43 automatically. BTW, yes
VE also recognizes 80x43 in VGA!
[EndTip]

[Tip][52] [ VE Supports MDA, CGA, EGA and VGA ]
VE 4.4a adds support for MDA/Hercules, CGA and EGA
to the existing VGA support. VE can now run on MDA,
Hercules, CGA, EGA and VGA equipped PCs. For MDA,
Hercules and CGA, 80x25 is the only supported
resolution. For EGA, 80x25 and 80x43 are available.
For VGA, 80x25, 80x43 and 80x50 are all available.

Start VE with the "-s" option to specify screen size
(e.g. "ve -s 80x50 filename.txt"). If no "-s" option is 
specified, VE starts at its default 80x25 resolution.
[EndTip]

[Tip][53] [ The Last Tip? ]
You are viewing the last tip! Congratulations for making it
to the end of the tip list. Keep viewing tips from time to
time to remind yourself what you have learned!

But wait! Is this REALLY the last tip? Perhaps you have a
great tip that you haven't seen in this set of tips? Please
submit it to webmaster@inverary.net for possible inclusion
in the next release of VE tips.
[EndTip]

